<?php
// vim: foldmethod=marker tabstop=4 shiftwidth=4 autoindent
/**
 *	Ethna_CacheManager.php
 *
 *	@author		Masaki Fujimoto <fujimoto@php.net>
 *  @license    http://www.opensource.org/licenses/bsd-license.php The BSD License
 *  @package    Ethna
 *	@version    $Id: Ethna_CacheManager.php,v 1.1 2006/06/05 14:53:12 fujimoto Exp $
 */

/**
 *	åޥ͡㥯饹
 *
 *	@author		Masaki Fujimoto <fujimoto@php.net>
 *	@access		public
 *	@package	Ethna
 */
class Ethna_CacheManager
{
	/**#@+	@access	private	*/

	/**	@var	string	ߤΥ͡ॹڡ */
	var $namespace = '';

	/**	@var	object	Ethna_Backend		backend֥ */
	var $backend;

	/**	@var	object	Ethna_Config		ꥪ֥	*/
	var $config;

	/**#@-*/

	/**
	 *	Ethna_CacheMaanger饹Υ󥹥󥹤
	 *
	 *	@access	public
	 *	@param	string	$type	å奿('localfile', 'memcache'...)
	 *	@return	object Ethna_CacheMaanger	Ethna_CacheManager֥
	 */
	function &getInstance($type)
	{
		static $instance = array();

		if (array_key_exists($type, $instance)) {
			return $instance[$type];
		}

        // TODO: use plugin
		$class_name = sprintf("Ethna_CacheManager_%s", ucfirst(strtolower($type)));
		$class_file = sprintf("%s/CacheManager/%s.php", dirname(__FILE__), $class_name);
		if (file_exists($class_file) == false) {
			$retval = Ethna::raiseError("invalid cache type: no such file ($class_file)", E_CACHE_INVALID_TYPE);
			return $retval;
		}
		include_once($class_file);
		if (class_exists($class_name) == false) {
			$retval = Ethna::raiseError("invalid cache type: class is not defined ($class_name)", E_CACHE_INVALID_TYPE);
			return $retval;
		}

		$instance[$type] =& new $class_name();

		return $instance[$type];
	}
    
    /**
     *  Ethna_CacheManager饹Υ󥹥ȥ饯
     *
     *  @access public
     */
    function Ethna_CacheManager()
    {
        $this->controller =& Ethna_Controller::getInstance();
        $this->backend =& $this->controller->getBackend();
        $this->config =& $this->controller->getConfig();
    }

	/**
	 *	å͡ॹڡ
	 *
	 *	@access	public
	 *	@return	string	ߤΥå͡ॹڡ
	 */
	function getNamespace($namespace)
	{
		return $this->namespace;
	}

	/**
	 *	å͡ॹڡꤹ
	 *
	 *	@access	public
	 *	@param	string	$namespace	͡ॹڡ
	 */
	function setNamespace($namespace)
	{
		$this->namespace = $namespace;
	}

	/**
	 *	åꤵ줿ͤ
	 *
	 *	åͤꤵƤϥå
	 *	ͤȤʤ롣å̵ͤlifetime
	 *	᤮Ƥ硢顼ȯPEAR_Error
	 *	֥ȤͤȤʤ롣
	 *
	 *	@access	public
	 *	@param	string	$key		å奭
	 *	@param	int		$lifetime	åͭ
	 *	@param	string	$namespace	å͡ॹڡ
	 *	@return	mixed	å
	 */
	function get($key, $lifetime = null, $namespace = null)
	{
	}

	/**
	 *	åκǽ
	 *
	 *	@access	public
	 *	@param	string	$key		å奭
	 *	@param	string	$namespace	å͡ॹڡ
	 *	@return	int		ǽ(unixtime)
	 */
	function getLastModified($key, $namespace = null)
	{
	}

	/**
	 *	åͤꤹ
	 *
	 *	@access	public
	 *	@param	string	$key		å奭
	 *	@param	mixed	$value		å
	 *	@param	int		$timestamp	åǽ(unixtime)
	 *	@param	string	$namespace	å͡ॹڡ
	 */
	function set($key, $value, $timestamp = null, $namespace = null)
	{
	}

	/**
	 *	ͤå夵Ƥ뤫ɤ
	 *
	 *	@access	public
	 *	@param	string	$key		å奭
	 *	@param	int		$lifetime	åͭ
	 *	@param	string	$namespace	å͡ॹڡ
	 */
	function isCached($key, $timestamp = null, $namespace = null)
	{
	}

	/**
	 *	å夫ͤ
	 *
	 *	@access	public
	 *	@param	string	$key		å奭
	 *	@param	string	$namespace	å͡ॹڡ
	 */
	function clear($key, $namespace = null)
	{
	}

	/**
	 *	åǡå
	 *
	 *	@access	public
	 *	@param	string	$key		å奭
	 *	@param	int		$timeout	åॢ
	 *	@param	string	$namespace	å͡ॹڡ
	 *	@return	bool	true: false:
	 */
	function lock($key, $timeout = 5, $namespace = null)
	{
		return false;
	}

	/**
	 *	åǡΥå
	 *
	 *	@access	public
	 *	@param	string	$key		å奭
	 *	@param	string	$namespace	å͡ॹڡ
	 *	@return	bool	true: false:
	 */
	function unlock($key, $namespace = null)
	{
		return false;
	}

	/**
	 * ̥ե饰ΩƤ
	 *
	 * MySQLʤɤĤλҥ饹ͭ
	 * 
	 * @access public
	 * @param bool $flag ե饰
	 */
	function setCompress($flag) {
		return false;
	}
}
?>
