<?php
// vim: foldmethod=marker
/**
 *  Ethna_Controller.php
 *
 *  @author     Masaki Fujimoto <fujimoto@php.net>
 *  @license    http://www.opensource.org/licenses/bsd-license.php The BSD License
 *  @package    Ethna
 *  @version    $Id: Ethna_Controller.php,v 1.51 2006/06/05 15:58:49 fujimoto Exp $
 */

// {{{ Ethna_Controller
/**
 *  ȥ饯饹
 *
 *  @todo       gatewayswitchƤȤ
 *
 *  @author     Masaki Fujimoto <fujimoto@php.net>
 *  @access     public
 *  @package    Ethna
 */
class Ethna_Controller
{
    /**#@+
     *  @access private
     */

    /** @var    string      ץꥱID */
    var $appid = 'ETHNA';

    /** @var    string      ץꥱ١ǥ쥯ȥ */
    var $base = '';

    /** @var    string      ץꥱ١URL */
    var $url = '';

    /** @var    string      ץꥱDSN(Data Source Name) */
    var $dsn;

    /** @var    array       ץꥱǥ쥯ȥ */
    var $directory = array(
        'action'        => 'app/action',
        'action_cli'    => 'app/action_cli',
        'action_xmlrpc' => 'app/action_xmlrpc',
        'app'           => 'app',
        'bin'           => 'bin',
        'etc'           => 'etc',
        'filter'        => 'app/filter',
        'locale'        => 'locale',
        'log'           => 'log',
        'plugins'       => array(),
        'template'      => 'template',
        'template_c'    => 'tmp',
        'tmp'           => 'tmp',
        'view'          => 'app/view',
    );

    /** @var    array       DB */
    var $db = array(
        ''              => DB_TYPE_RW,
    );

    /** @var    array       ĥ */
    var $ext = array(
        'php'           => 'php',
        'tpl'           => 'tpl',
    );

    /** @var    array       饹 */
    var $class = array(
        'class'         => 'Ethna_ClassFactory',
        'backend'       => 'Ethna_Backend',
        'config'        => 'Ethna_Config',
        'db'            => 'Ethna_DB',
        'error'         => 'Ethna_ActionError',
        'form'          => 'Ethna_ActionForm',
        'i18n'          => 'Ethna_I18N',
        'logger'        => 'Ethna_Logger',
        'session'       => 'Ethna_Session',
        'sql'           => 'Ethna_AppSQL',
        'view'          => 'Ethna_ViewClass',
    );

    /** @var    array       ե륿 */
    var $filter = array(
    );

    /** @var    string      Ѹ */
    var $language;

    /** @var    string      ƥ¦󥳡ǥ */
    var $system_encoding;

    /** @var    string      饤¦󥳡ǥ */
    var $client_encoding;

    /** @var    string  ߼¹Υ̾ */
    var $action_name;

    /** @var    string  ߼¹XMLRPC᥽å̾ */
    var $xmlrpc_method_name;

    /** @var    array   forward */
    var $forward = array();

    /** @var    array   action */
    var $action = array();

    /** @var    array   action(CLI) */
    var $action_cli = array();

    /** @var    array   action(XMLRPC) */
    var $action_xmlrpc = array();

    /** @var    array   ץꥱޥ͡ */
    var $manager = array();

    /** @var    array   smarty modifier */
    var $smarty_modifier_plugin = array();

    /** @var    array   smarty function */
    var $smarty_function_plugin = array();

    /** @var    array   smarty block */
    var $smarty_block_plugin = array();

    /** @var    array   smarty prefilter */
    var $smarty_prefilter_plugin = array();

    /** @var    array   smarty postfilter */
    var $smarty_postfilter_plugin = array();

    /** @var    array   smarty outputfilter */
    var $smarty_outputfilter_plugin = array();

    /** @var    array   ե륿(Ethna_Filter֥Ȥ) */
    var $filter_chain = array();

    /** @var    object  Ethna_ClassFactory  饹եȥꥪ֥ */
    var $class_factory = null;

    /** @var    object  Ethna_ActionForm    ե४֥ */
    var $action_form = null;

    /** @var    object  Ethna_View          ӥ塼֥ */
    var $view = null;

    /** @var    object  Ethna_Config        ꥪ֥ */
    var $config = null;

    /** @var    object  Ethna_Logger        ֥ */
    var $logger = null;

    /** @var    string  ꥯȤΥȥ(www/cli/rest/xmlrpc/soap...) */
    var $gateway = GATEWAY_WWW;

    /**#@-*/


    /**
     *  Ethna_Controller饹Υ󥹥ȥ饯
     *
     *  @access     public
     */
    function Ethna_Controller($gateway = GATEWAY_WWW)
    {
        $GLOBALS['_Ethna_controller'] =& $this;
        if ($this->base == "") {
            $this->base = BASE;
        }

        $this->gateway = $gateway;

        // 饹եȥꥪ֥Ȥ
        $class_factory = $this->class['class'];
        $this->class_factory =& new $class_factory($this, $this->class);

        // 顼ϥɥ
        Ethna::setErrorCallback(array(&$this, 'handleError'));

        // ǥ쥯ȥ̾(Хѥ->Хѥ)
        foreach ($this->directory as $key => $value) {
            if ($key == 'plugins') {
                // Smartyץ饰ǥ쥯ȥǻꤹ
                $tmp = array(SMARTY_DIR . 'plugins');
                foreach (to_array($value) as $elt) {
                    if (Ethna_Util::isAbsolute($elt) == false) {
                        $tmp[] = $this->base . (empty($this->base) ? '' : '/') . $elt;
                    }
                }
                $this->directory[$key] = $tmp;
            } else {
                if (Ethna_Util::isAbsolute($value) == false) {
                    $this->directory[$key] = $this->base . (empty($this->base) ? '' : '/') . $value;
                }
            }
        }

        // 
        list($this->language, $this->system_encoding, $this->client_encoding) = $this->_getDefaultLanguage();

        $this->config =& $this->getConfig();
        $this->dsn = $this->_prepareDSN();
        $this->url = $this->config->get('url');

        // ϳ
        $this->logger =& $this->getLogger();
        $this->logger->begin();

        // Ethnaޥ͡
        $this->_activateEthnaManager();
    }

    /**
     *  (ߥƥ֤)ȥΥ󥹥󥹤֤
     *
     *  @access public
     *  @return object  Ethna_Controller    ȥΥ󥹥
     *  @static
     */
    function &getInstance()
    {
        if (isset($GLOBALS['_Ethna_controller'])) {
            return $GLOBALS['_Ethna_controller'];
        } else {
            $_ret_object = null;
            return $_ret_object;
        }
    }

    /**
     *  ץꥱID֤
     *
     *  @access public
     *  @return string  ץꥱID
     */
    function getAppId()
    {
        return ucfirst(strtolower($this->appid));
    }

    /**
     *  ץꥱIDå
     *
     *  @access public
     *  @param  string  $id     ץꥱID
     *  @return mixed   true:OK Ethna_Error:NG
     */
    function checkAppId($id)
    {
        if (strcasecmp($id, 'ethna') == 0) {
            return Ethna::raiseError(sprintf("Application Id [%s] is reserved\n", $id));
        }
        if (preg_match('/^[0-9a-zA-Z]+$/', $id) == 0) {
            return Ethna::raiseError(sprintf("Only Numeric(0-9) and Alphabetical(A-Z) is allowed for Application Id\n"));
        }

        return true;
    }

    /**
     *  DSN֤
     *
     *  @access public
     *  @param  string  $db_key DB
     *  @return string  DSN
     */
    function getDSN($db_key = "")
    {
        if (isset($this->dsn[$db_key]) == false) {
            return null;
        }
        return $this->dsn[$db_key];
    }

    /**
     *  DSNλ³³֤
     *
     *  @access public
     *  @param  string  $db_key DB
     *  @return bool    true:persistent false:non-persistent(뤤̵)
     */
    function getDSN_persistent($db_key = "")
    {
        $key = sprintf("dsn%s_persistent", $db_key == "" ? "" : "_$db_key");

        $dsn_persistent = $this->config->get($key);
        if (is_null($dsn_persistent)) {
            return false;
        }
        return $dsn_persistent;
    }

    /**
     *  DB֤
     *
     *  @access public
     *  @param  string  $db_key DB("", "r", "rw", "default", "blog_r"...)
     *  @return string  $db_keyбDB(̵꤬null)
     */
    function getDBType($db_key = null)
    {
        if (is_null($db_key)) {
            // ֤
            return $this->db;
        }

        if (isset($this->db[$db_key]) == false) {
            return null;
        }
        return $this->db[$db_key];
    }

    /**
     *  ץꥱ١URL֤
     *
     *  @access public
     *  @return string  ץꥱ١URL
     */
    function getURL()
    {
        return $this->url;
    }

    /**
     *  ץꥱ١ǥ쥯ȥ֤
     *
     *  @access public
     *  @return string  ץꥱ١ǥ쥯ȥ
     */
    function getBasedir()
    {
        return $this->base;
    }

    /**
     *  饤ȥ/줫ƥץ졼ȥǥ쥯ȥ̾ꤹ
     *
     *  @access public
     *  @return string  ƥץ졼ȥǥ쥯ȥ
     */
    function getTemplatedir()
    {
        $template = $this->getDirectory('template');

        // ̥ǥ쥯ȥ
        if (file_exists($template . '/' . $this->language)) {
            $template .= '/' . $this->language;
        }

        return $template;
    }

    /**
     *  ǥ쥯ȥ̾ꤹ
     *
     *  @access public
     *  @return string  ǥ쥯ȥ
     */
    function getActiondir($gateway = null)
    {
        $key = 'action';
        $gateway = is_null($gateway) ? $this->getGateway() : $gateway;
        switch ($gateway) {
        case GATEWAY_WWW:
            $key = 'action';
            break;
        case GATEWAY_CLI:
            $key = 'action_cli';
            break;
        case GATEWAY_XMLRPC:
            $key = 'action_xmlrpc';
            break;
        }

        return (empty($this->directory[$key]) ? ($this->base . (empty($this->base) ? '' : '/')) : ($this->directory[$key] . "/"));
    }

    /**
     *  ӥ塼ǥ쥯ȥ̾ꤹ
     *
     *  @access public
     *  @return string  ǥ쥯ȥ
     */
    function getViewdir()
    {
        return (empty($this->directory['view']) ? ($this->base . (empty($this->base) ? '' : '/')) : ($this->directory['view'] . "/"));
    }

    /**
     *  ץꥱǥ쥯ȥ֤
     *
     *  @access public
     *  @param  string  $key    ǥ쥯ȥ꥿("tmp", "template"...)
     *  @return string  $keyбץꥱǥ쥯ȥ(̵꤬null)
     */
    function getDirectory($key)
    {
        // for B.C.
        if ($key == 'app' && isset($this->directory[$key]) == false) {
            return BASE . '/app';
        }

        if (isset($this->directory[$key]) == false) {
            return null;
        }
        return $this->directory[$key];
    }

    /**
     *  ץꥱĥ֤
     *
     *  @access public
     *  @param  string  $key    ĥҥ("php", "tpl"...)
     *  @return string  $keyбĥ(̵꤬null)
     */
    function getExt($key)
    {
        if (isset($this->ext[$key]) == false) {
            return null;
        }
        return $this->ext[$key];
    }

    /**
     *  饹եȥꥪ֥ȤΥ(R)
     *
     *  @access public
     *  @return object  Ethna_ClassFactory  饹եȥꥪ֥
     */
    function &getClassFactory()
    {
        return $this->class_factory;
    }

    /**
     *  󥨥顼֥ȤΥ
     *
     *  @access public
     *  @return object  Ethna_ActionError   󥨥顼֥
     */
    function &getActionError()
    {
        return $this->class_factory->getObject('error');
    }

    /**
     *  ե४֥ȤΥ
     *
     *  @access public
     *  @return object  Ethna_ActionForm    ե४֥
     */
    function &getActionForm()
    {
        // Ū˥饹եȥѤƤʤ
        return $this->action_form;
    }

    /**
     *  ӥ塼֥ȤΥ
     *
     *  @access public
     *  @return object  Ethna_View          ӥ塼֥
     */
    function &getView()
    {
        // Ū˥饹եȥѤƤʤ
        return $this->view;
    }

    /**
     *  backend֥ȤΥ
     *
     *  @access public
     *  @return object  Ethna_Backend   backend֥
     */
    function &getBackend()
    {
        return $this->class_factory->getObject('backend');
    }

    /**
     *  ꥪ֥ȤΥ
     *
     *  @access public
     *  @return object  Ethna_Config    ꥪ֥
     */
    function &getConfig()
    {
        return $this->class_factory->getObject('config');
    }

    /**
     *  i18n֥ȤΥ(R)
     *
     *  @access public
     *  @return object  Ethna_I18N  i18n֥
     */
    function &getI18N()
    {
        return $this->class_factory->getObject('i18n');
    }

    /**
     *  ֥ȤΥ
     *
     *  @access public
     *  @return object  Ethna_Logger        ֥
     */
    function &getLogger()
    {
        return $this->class_factory->getObject('logger');
    }

    /**
     *  å󥪥֥ȤΥ
     *
     *  @access public
     *  @return object  Ethna_Session       å󥪥֥
     */
    function &getSession()
    {
        return $this->class_factory->getObject('session');
    }

    /**
     *  SQL֥ȤΥ
     *
     *  @access public
     *  @return object  Ethna_AppSQL    SQL֥
     */
    function &getSQL()
    {
        return $this->class_factory->getObject('sql');
    }

    /**
     *  ޥ֤͡
     *
     *  @access public
     *  @return array   ޥ͡
     */
    function getManagerList()
    {
        return $this->manager;
    }

    /**
     *  ¹Υ֤̾
     *
     *  @access public
     *  @return string  ¹Υ̾
     */
    function getCurrentActionName()
    {
        return $this->action_name;
    }

    /**
     *  ¹XMLRPC᥽å֤̾
     *
     *  @access public
     *  @return string  ¹XMLRPC᥽å̾
     */
    function getXmlrpcMethodName()
    {
        return $this->xmlrpc_method_name;
    }

    /**
     *  Ѹ
     *
     *  @access public
     *  @return array   Ѹ,ƥ२󥳡ǥ̾,饤ȥ󥳡ǥ̾
     */
    function getLanguage()
    {
        return array($this->language, $this->system_encoding, $this->client_encoding);
    }

    /**
     *  ȥ
     *
     *  @access public
     */
    function getGateway()
    {
        return $this->gateway;
    }

    /**
     *  ȥ⡼ɤꤹ
     *
     *  @access public
     */
    function setGateway($gateway)
    {
        $this->gateway = $gateway;
    }

    /**
     *  ץꥱΥȥݥ
     *
     *  @access public
     *  @param  string  $class_name     ץꥱ󥳥ȥΥ饹̾
     *  @param  mixed   $action_name    Υ̾(ά)
     *  @param  mixed   $fallback_action_name   󤬷Ǥʤä˼¹Ԥ륢̾(ά)
     *  @static
     */
    function main($class_name, $action_name = "", $fallback_action_name = "")
    {
        $c =& new $class_name;
        $c->trigger($action_name, $fallback_action_name);
    }

    /**
     *  CLIץꥱΥȥݥ
     *
     *  @access public
     *  @param  string  $class_name     ץꥱ󥳥ȥΥ饹̾
     *  @param  string  $action_name    ¹Ԥ륢̾
     *  @param  bool    $enable_filter  ե륿ͭˤ뤫ɤ
     *  @static
     */
    function main_CLI($class_name, $action_name, $enable_filter = true)
    {
        $c =& new $class_name(GATEWAY_CLI);
        $c->action_cli[$action_name] = array();
        $c->trigger($action_name, "", $enable_filter);
    }

    /**
     *  XMLRPCץꥱΥȥݥ
     *
     *  @access public
     *  @static
     */
    function main_XMLRPC($class_name)
    {
        if (extension_loaded('xmlrpc') == false) {
            die("xmlrpc extension is required to enable this gateway");
        } else if (ini_get('always_populate_raw_post_data') == false) {
            die("always_populate_raw_post_data ini variable should be true to enable this gateway");
        }

        $c =& new $class_name(GATEWAY_XMLRPC);
        $c->trigger("", "", false);
    }

    /**
     *  SOAPץꥱΥȥݥ
     *
     *  @access public
     *  @param  string  $class_name     ץꥱ󥳥ȥΥ饹̾
     *  @param  mixed   $action_name    Υ̾(ά)
     *  @param  mixed   $fallback_action_name   󤬷Ǥʤä˼¹Ԥ륢̾(ά)
     *  @static
     */
    function main_SOAP($class_name, $action_name = "", $fallback_action_name = "")
    {
        $c =& new $class_name(GATEWAY_SOAP);
        $c->trigger($action_name, $fallback_action_name);
    }

    /**
     *  ե졼ν򳫻Ϥ
     *
     *  @access public
     *  @param  mixed   $default_action_name    Υ̾
     *  @param  mixed   $fallback_action_name   ̾Ǥʤä˼¹Ԥ륢̾
     *  @param  bool    $enable_filter  ե륿ͭˤ뤫ɤ
     *  @return mixed   0:ｪλ Ethna_Error:顼
     */
    function trigger($default_action_name = "", $fallback_action_name = "", $enable_filter = true)
    {
        // ե륿
        if ($enable_filter) {
            $this->_createFilterChain();
        }

        // ¹ե륿
        for ($i = 0; $i < count($this->filter_chain); $i++) {
            $r = $this->filter_chain[$i]->preFilter();
            if (Ethna::isError($r)) {
                return $r;
            }
        }

        // trigger
        switch ($this->getGateway()) {
        case GATEWAY_WWW:
            $this->_trigger_WWW($default_action_name, $fallback_action_name);
            break;
        case GATEWAY_CLI:
            $this->_trigger_CLI($default_action_name);
            break;
        case GATEWAY_XMLRPC:
            $this->_trigger_XMLRPC();
            break;
        case GATEWAY_SOAP:
            $this->_trigger_SOAP();
            break;
        }

        // ¹Ըե륿
        for ($i = count($this->filter_chain) - 1; $i >= 0; $i--) {
            $r = $this->filter_chain[$i]->postFilter();
            if (Ethna::isError($r)) {
                return $r;
            }
        }
    }

    /**
     *  ե졼ν¹Ԥ(WWW)
     *
     *  $default_action_name󤬻ꤵ줿硢ǻꤵ줿
     *  ʳϼդʤ(ꤵƤʤ󤬻ꤵ줿
     *  硢Ƭǻꤵ줿󤬼¹Ԥ)
     *
     *  @access private
     *  @param  mixed   $default_action_name    Υ̾
     *  @param  mixed   $fallback_action_name   ̾Ǥʤä˼¹Ԥ륢̾
     *  @return mixed   0:ｪλ Ethna_Error:顼
     */
    function _trigger_WWW($default_action_name = "", $fallback_action_name = "")
    {
        // ̾μ
        $action_name = $this->_getActionName($default_action_name, $fallback_action_name);

        // μ
        $action_obj =& $this->_getAction($action_name);
        if (is_null($action_obj)) {
            if ($fallback_action_name != "") {
                $this->logger->log(LOG_DEBUG, 'undefined action [%s] -> try fallback action [%s]', $action_name, $fallback_action_name);
                $action_obj =& $this->_getAction($fallback_action_name);
            }
            if (is_null($action_obj)) {
                return Ethna::raiseError("undefined action [%s]", E_APP_UNDEFINED_ACTION, $action_name);
            } else {
                $action_name = $fallback_action_name;
            }
        }

        // ¹ե륿
        for ($i = 0; $i < count($this->filter_chain); $i++) {
            $r = $this->filter_chain[$i]->preActionFilter($action_name);
            if ($r != null) {
                $this->logger->log(LOG_DEBUG, 'action [%s] -> [%s] by %s', $action_name, $r, get_class($this->filter_chain[$i]));
                $action_name = $r;
            }
        }
        $this->action_name = $action_name;

        // 
        $this->_setLanguage($this->language, $this->system_encoding, $this->client_encoding);

        // ֥
        $form_name = $this->getActionFormName($action_name);
        $this->action_form =& new $form_name($this);
        $this->action_form->setFormVars();

        // Хåɽ¹
        $backend =& $this->getBackend();
        $backend->setActionForm($this->action_form);

        $session =& $this->getSession();
        $session->restore();
        $forward_name = $backend->perform($action_name);

        // ¹Ըե륿
        for ($i = count($this->filter_chain) - 1; $i >= 0; $i--) {
            $r = $this->filter_chain[$i]->postActionFilter($action_name, $forward_name);
            if ($r != null) {
                $this->logger->log(LOG_DEBUG, 'forward [%s] -> [%s] by %s', $forward_name, $r, get_class($this->filter_chain[$i]));
                $forward_name = $r;
            }
        }

        // ȥꤹ(ץ)
        $forward_name = $this->_sortForward($action_name, $forward_name);

        if ($forward_name != null) {
            $view_class_name = $this->getViewClassName($forward_name);
            $this->view =& new $view_class_name($backend, $forward_name, $this->_getForwardPath($forward_name));
            $this->view->preforward();
            $this->view->forward();
        }

        return 0;
    }

    /**
     *  ե졼ν¹Ԥ(CLI)
     *
     *  @access private
     *  @param  mixed   $default_action_name    Υ̾
     *  @return mixed   0:ｪλ Ethna_Error:顼
     */
    function _trigger_CLI($default_action_name = "")
    {
        return $this->_trigger_WWW($default_action_name);
    }

    /**
     *  ե졼ν¹Ԥ(XMLRPC)
     *
     *  @access private
     *  @param  mixed   $action_name    Υ̾
     *  @return mixed   0:ｪλ Ethna_Error:顼
     */
    function _trigger_XMLRPC($action_name = "")
    {
        $xmlrpc_gateway_method_name = "_Ethna_XmlrpcGateway";

        $xmlrpc_server = xmlrpc_server_create();
        $method = null;
        $param = xmlrpc_decode_request($GLOBALS['HTTP_RAW_POST_DATA'], $method);
        $this->xmlrpc_method_name = $method;

        $request = xmlrpc_encode_request($xmlrpc_gateway_method_name, $param, array("output_type" => "xml", "verbosity" => "pretty", "escaping" => array('markup'), "version" => "xmlrpc", "encoding" => "utf-8")); 
        xmlrpc_server_register_method($xmlrpc_server, $xmlrpc_gateway_method_name, $xmlrpc_gateway_method_name);
        $r = xmlrpc_server_call_method($xmlrpc_server, $request, null, array("output_type" => "xml", "verbosity" => "pretty", "escaping" => array('markup'), "version" => "xmlrpc", "encoding" => "utf-8"));

        header('Content-Length: ' . strlen($r));
        header('Content-Type: text/xml; charset=UTF-8');
        print $r;
    }

    /**
     *  _trigger_XMLRPCΥХå᥽å
     *
     *  @access public
     */
    function trigger_XMLRPC($method, $param)
    {
        // μ
        $action_obj =& $this->_getAction($method);
        if (is_null($action_obj)) {
            return Ethna::raiseError("undefined xmlrpc method [%s]", E_APP_UNDEFINED_ACTION, $method);
        }

        // ֥
        $form_name = $this->getActionFormName($method);
        $this->action_form =& new $form_name($this);
        $def = $this->action_form->getDef();
        $n = 0;
        foreach ($def as $key => $value) {
            if (isset($param[$n]) == false) {
                $this->action_form->set($key, null);
            } else {
                $this->action_form->set($key, $param[$n]);
            }
            $n++;
        }

        // Хåɽ¹
        $backend =& $this->getBackend();
        $session =& $this->getSession();
        $session->restore();
        $r = $backend->perform($method);

        return $r;
    }

    /**
     *  SOAPե졼ν¹Ԥ
     *
     *  @access private
     */
    function _trigger_SOAP()
    {
        // SOAPȥꥯ饹
        $gg =& new Ethna_SOAP_GatewayGenerator();
        $script = $gg->generate();
        eval($script);

        // SOAPꥯȽ
        $server =& new SoapServer(null, array('uri' => $this->config->get('url')));
        $server->setClass($gg->getClassName());
        $server->handle();
    }

    /**
     *  顼ϥɥ
     *
     *  顼ȯɲýԤϤΥ᥽åɤ򥪡С饤ɤ
     *  (顼ȥ᡼ݥǥեȤǤϥϻ˥顼ȥ᡼
     *  뤬顼ȯ̤˥顼ȥ᡼򤳤
     *  뤳Ȥǽ)
     *
     *  @access public
     *  @param  object  Ethna_Error     顼֥
     */
    function handleError(&$error)
    {
        // 
        list ($log_level, $dummy) = $this->logger->errorLevelToLogLevel($error->getLevel());
        $message = $error->getMessage();
        $this->logger->log($log_level, sprintf("%s [ERROR CODE(%d)]", $message, $error->getCode()));
    }

    /**
     *  顼å
     *
     *  @access public
     *  @param  int     $code       顼
     *  @return string  顼å
     */
    function getErrorMessage($code)
    {
        $message_list =& $GLOBALS['_Ethna_error_message_list'];
        for ($i = count($message_list)-1; $i >= 0; $i--) {
            if (array_key_exists($code, $message_list[$i])) {
                return $message_list[$i][$code];
            }
        }
        return null;
    }

    /**
     *  ¹Ԥ륢֤̾
     *
     *  @access private
     *  @param  mixed   $default_action_name    Υ̾
     *  @return string  ¹Ԥ륢̾
     */
    function _getActionName($default_action_name, $fallback_action_name)
    {
        // եफ׵ᤵ줿̾
        $form_action_name = $this->_getActionName_Form();
        $form_action_name = preg_replace('/[^a-z0-9\-_]+/i', '', $form_action_name);
        $this->logger->log(LOG_DEBUG, 'form_action_name[%s]', $form_action_name);

        // Ethnaޥ͡ؤΥեफΥꥯȤϵ
        if ($form_action_name == "__ethna_info__" ||
            $form_action_name == "__ethna_unittest__") {
            $form_action_name = "";
        }

        // եफλ̵꤬ϥȥݥȤ˻ꤵ줿ǥեͤѤ
        if ($form_action_name == "" && count($default_action_name) > 0) {
            $tmp = is_array($default_action_name) ? $default_action_name[0] : $default_action_name;
            if ($tmp{strlen($tmp)-1} == '*') {
                $tmp = substr($tmp, 0, -1);
            }
            $this->logger->log(LOG_DEBUG, '-> default_action_name[%s]', $tmp);
            $action_name = $tmp;
        } else {
            $action_name = $form_action_name;
        }

        // ȥݥȤ󤬻ꤵƤϻʳΥ̾ϵݤ
        if (is_array($default_action_name)) {
            if ($this->_isAcceptableActionName($action_name, $default_action_name) == false) {
                // ʳΥ̾ǹä$fallback_action_name(or ǥե)
                $tmp = $fallback_action_name != "" ? $fallback_action_name : $default_action_name[0];
                if ($tmp{strlen($tmp)-1} == '*') {
                    $tmp = substr($tmp, 0, -1);
                }
                $this->logger->log(LOG_DEBUG, '-> fallback_action_name[%s]', $tmp);
                $action_name = $tmp;
            }
        }

        $this->logger->log(LOG_DEBUG, '<<< action_name[%s] >>>', $action_name);

        return $action_name;
    }

    /**
     *  եˤ׵ᤵ줿֤̾
     *
     *  ץꥱ˱ƤΥ᥽åɤ򥪡С饤ɤƲ
     *  ǥեȤǤ"action_"ǻϤޤեͤ"action_"ʬ
     *  ("action_sample"ʤ"sample")̾Ȥưޤ
     *
     *  @access protected
     *  @return string  եˤ׵ᤵ줿̾
     */
    function _getActionName_Form()
    {
        if (isset($_SERVER['REQUEST_METHOD']) == false) {
            return null;
        }

        if (strcasecmp($_SERVER['REQUEST_METHOD'], 'post') == 0) {
            $http_vars =& $_POST;
        } else {
            $http_vars =& $_GET;
        }

        // եͤꥯȤ줿̾
        $action_name = $sub_action_name = null;
        foreach ($http_vars as $name => $value) {
            if ($value == "" || strncmp($name, 'action_', 7) != 0) {
                continue;
            }

            $tmp = substr($name, 7);

            // type="image"б
            if (preg_match('/_x$/', $name) || preg_match('/_y$/', $name)) {
                $tmp = substr($tmp, 0, strlen($tmp)-2);
            }

            // value="dummy"ȤʤäƤΤͥ٤򲼤
            if ($value == "dummy") {
                $sub_action_name = $tmp;
            } else {
                $action_name = $tmp;
            }
        }
        if ($action_name == null) {
            $action_name = $sub_action_name;
        }

        return $action_name;
    }

    /**
     *  ̾ꤹ륯/HTML
     *
     *  @access public
     *  @param  string  $action action to request
     *  @param  string  $type   hidden, url...
     *  @todo   consider gateway
     */
    function getActionRequest($action, $type = "hidden")
    {
        $s = null; 
        if ($type == "hidden") {
            $s = sprintf('<input type="hidden" name="%s" value="true">', htmlspecialchars($action, ENT_QUOTES));
        } else if ($type == "url") {
            $s = sprintf('%s=true', urlencode($action));
        }
        return $s;
    }

    /**
     *  եˤ׵ᤵ줿̾б֤
     *
     *  @access private
     *  @param  string  $action_name    ̾
     *  @return array   
     */
    function &_getAction($action_name, $gateway = null)
    {
        $action = array();
        $gateway = is_null($gateway) ? $this->getGateway() : $gateway;
        switch ($gateway) {
        case GATEWAY_WWW:
            $action =& $this->action;
            break;
        case GATEWAY_CLI:
            $action =& $this->action_cli;
            break;
        case GATEWAY_XMLRPC:
            $action =& $this->action_xmlrpc;
            break;
        }

        $action_obj = array();
        if (isset($action[$action_name])) {
            $action_obj = $action[$action_name];
            if (isset($action_obj['inspect']) && $action_obj['inspect']) {
                return $action_obj;
            }
        } else {
            $this->logger->log(LOG_DEBUG, "action [%s] is not defined -> try default", $action_name);
        }

        // 󥹥ץȤΥ󥯥롼
        $this->_includeActionScript($action_obj, $action_name);

        // άͤ
        if (isset($action_obj['class_name']) == false) {
            $action_obj['class_name'] = $this->getDefaultActionClass($action_name);
        }

        if (isset($action_obj['form_name']) == false) {
            $action_obj['form_name'] = $this->getDefaultFormClass($action_name);
        } else if (class_exists($action_obj['form_name']) == false) {
            // ꤵ줿ե९饹ƤʤϷٹ
            $this->logger->log(LOG_WARNING, 'stated form class is not defined [%s]', $action_obj['form_name']);
        }

        // ɬ׾γǧ
        if (class_exists($action_obj['class_name']) == false) {
            $this->logger->log(LOG_NOTICE, 'action class is not defined [%s]', $action_obj['class_name']);
            $_ret_object = null;
            return $_ret_object;
        }
        if (class_exists($action_obj['form_name']) == false) {
            // ե९饹̤Ǥɤ
            $class_name = $this->class_factory->getObjectName('form');
            $this->logger->log(LOG_DEBUG, 'form class is not defined [%s] -> falling back to default [%s]', $action_obj['form_name'], $class_name);
            $action_obj['form_name'] = $class_name;
        }

        $action_obj['inspect'] = true;
        $action[$action_name] = $action_obj;
        return $action[$action_name];
    }

    /**
     *  ̾ȥ󥯥饹ͤ˴Ťꤹ
     *
     *  @access protected
     *  @param  string  $action_name    ̾
     *  @param  string  $retval         󥯥饹
     *  @return string  
     */
    function _sortForward($action_name, $retval)
    {
        return $retval;
    }

    /**
     *  ե륿
     *
     *  @access private
     */
    function _createFilterChain()
    {
        $this->filter_chain = array();
        foreach ($this->filter as $filter) {
            $file = sprintf("%s/%s.%s", $this->getDirectory('filter'), $filter, $this->getExt('php'));
            if (file_exists($file)) {
                include_once($file);
            }
            if (class_exists($filter)) {
                $this->filter_chain[] =& new $filter($this);
            }
        }
    }

    /**
     *  ̾¹ԵĤƤΤɤ֤
     *
     *  @access private
     *  @param  string  $action_name            ꥯȤ줿̾
     *  @param  array   $default_action_name    ĤƤ륢̾
     *  @return bool    true: false:Ե
     */
    function _isAcceptableActionName($action_name, $default_action_name)
    {
        foreach (to_array($default_action_name) as $name) {
            if ($action_name == $name) {
                return true;
            } else if ($name{strlen($name)-1} == '*') {
                if (strncmp($action_name, substr($name, 0, -1), strlen($name)-1) == 0) {
                    return true;
                }
            }
        }
        return false;
    }

    /**
     *  ꤵ줿Υե९饹֤̾(֥ȤϹԤʤ)
     *
     *  @access public
     *  @param  string  $action_name    ̾
     *  @return string  Υե९饹̾
     */
    function getActionFormName($action_name)
    {
        $action_obj =& $this->_getAction($action_name);
        if (is_null($action_obj)) {
            return null;
        }

        return $action_obj['form_name'];
    }

    /**
     *  бե९饹̾ά줿Υǥեȥ饹֤̾
     *
     *  ǥեȤǤ[ץID]_Form_[̾]ȤʤΤǹ߱ƥХ饤ɤ
     *
     *  @access public
     *  @param  string  $action_name    ̾
     *  @return string  ե̾
     */
    function getDefaultFormClass($action_name, $gateway = null)
    {
        $gateway_prefix = $this->_getGatewayPrefix($gateway);

        $postfix = preg_replace('/_(.)/e', "strtoupper('\$1')", ucfirst($action_name));
        $r = sprintf("%s_%sForm_%s", $this->getAppId(), $gateway_prefix ? $gateway_prefix . "_" : "", $postfix);
        $this->logger->log(LOG_DEBUG, "default action class [%s]", $r);

        return $r;
    }

    /**
     *  getDefaultFormClass()Ǽ饹̾饢̾
     *
     *  getDefaultFormClass()򥪡С饤ɤ硢碌ƥС饤
     *  뤳Ȥ侩(ɬܤǤϤʤ)
     *
     *  @access public
     *  @param  string  $class_name     ե९饹̾
     *  @return string  ̾
     */
    function actionFormToName($class_name)
    {
        $prefix = sprintf("%s_Form_", $this->getAppId());
        if (preg_match("/$prefix(.*)/", $class_name, $match) == 0) {
            // ʥ饹̾
            return null;
        }
        $target = $match[1];

        $action_name = substr(preg_replace('/([A-Z])/e', "'_' . strtolower('\$1')", $target), 1);

        return $action_name;
    }

    /**
     *  бեѥ̾ά줿Υǥեȥѥ֤̾
     *
     *  ǥեȤǤ_getDefaultActionPath()Ʊ̤֤(1ե
     *  󥯥饹ȥե९饹Ҥ)Τǡߤ˱
     *  С饤ɤ
     *
     *  @access public
     *  @param  string  $action_name    ̾
     *  @return string  form class륹ץȤΥѥ̾
     */
    function getDefaultFormPath($action_name)
    {
        return $this->getDefaultActionPath($action_name);
    }

    /**
     *  ꤵ줿Υ饹֤̾(֥ȤϹԤʤ)
     *
     *  @access public
     *  @param  string  $action_name    ̾
     *  @return string  Υ饹̾
     */
    function getActionClassName($action_name)
    {
        $action_obj =& $this->_getAction($action_name);
        if ($action_obj == null) {
            return null;
        }

        return $action_obj['class_name'];
    }

    /**
     *  б륢󥯥饹̾ά줿Υǥեȥ饹֤̾
     *
     *  ǥեȤǤ[ץID]_Action_[̾]ȤʤΤǹ߱ƥХ饤ɤ
     *
     *  @access public
     *  @param  string  $action_name    ̾
     *  @return string  󥯥饹̾
     */
    function getDefaultActionClass($action_name, $gateway = null)
    {
        $gateway_prefix = $this->_getGatewayPrefix($gateway);

        $postfix = preg_replace('/_(.)/e', "strtoupper('\$1')", ucfirst($action_name));
        $r = sprintf("%s_%sAction_%s", $this->getAppId(), $gateway_prefix ? $gateway_prefix . "_" : "", $postfix);
        $this->logger->log(LOG_DEBUG, "default action class [%s]", $r);

        return $r;
    }

    /**
     *  getDefaultActionClass()Ǽ饹̾饢̾
     *
     *  getDefaultActionClass()򥪡С饤ɤ硢碌ƥС饤
     *  뤳Ȥ侩(ɬܤǤϤʤ)
     *
     *  @access public
     *  @param  string  $class_name     󥯥饹̾
     *  @return string  ̾
     */
    function actionClassToName($class_name)
    {
        $prefix = sprintf("%s_Action_", $this->getAppId());
        if (preg_match("/$prefix(.*)/", $class_name, $match) == 0) {
            // ʥ饹̾
            return null;
        }
        $target = $match[1];

        $action_name = substr(preg_replace('/([A-Z])/e', "'_' . strtolower('\$1')", $target), 1);

        return $action_name;
    }

    /**
     *  б륢ѥ̾ά줿Υǥեȥѥ֤̾
     *
     *  ǥեȤǤ"foo_bar" -> "/Foo/Bar.php"ȤʤΤǹ߱ƥС饤ɤ
     *
     *  @access public
     *  @param  string  $action_name    ̾
     *  @return string  󥯥饹륹ץȤΥѥ̾
     */
    function getDefaultActionPath($action_name)
    {
        $r = preg_replace('/_(.)/e', "'/' . strtoupper('\$1')", ucfirst($action_name)) . '.' . $this->getExt('php');
        $this->logger->log(LOG_DEBUG, "default action path [%s]", $r);

        return $r;
    }

    /**
     *  ꤵ줿̾бӥ塼饹֤̾(֥ȤϹԤʤ)
     *
     *  @access public
     *  @param  string  $forward_name   ̾
     *  @return string  view classΥ饹̾
     */
    function getViewClassName($forward_name)
    {
        if ($forward_name == null) {
            return null;
        }

        if (isset($this->forward[$forward_name])) {
            $forward_obj = $this->forward[$forward_name];
        } else {
            $forward_obj = array();
        }

        if (isset($forward_obj['view_name'])) {
            $class_name = $forward_obj['view_name'];
            if (class_exists($class_name)) {
                return $class_name;
            }
        } else {
            $class_name = null;
        }

        // viewΥ󥯥롼
        $this->_includeViewScript($forward_obj, $forward_name);

        if (is_null($class_name) == false && class_exists($class_name)) {
            return $class_name;
        } else if (is_null($class_name) == false) {
            $this->logger->log(LOG_WARNING, 'stated view class is not defined [%s] -> try default', $class_name);
        }

        $class_name = $this->getDefaultViewClass($forward_name);
        if (class_exists($class_name)) {
            return $class_name;
        } else {
            $class_name = $this->class_factory->getObjectName('view');
            $this->logger->log(LOG_DEBUG, 'view class is not defined for [%s] -> use default [%s]', $forward_name, $class_name);
            return $class_name;
        }
    }

    /**
     *  ̾бӥ塼饹̾ά줿Υǥեȥ饹֤̾
     *
     *  ǥեȤǤ[ץID]_View_[̾]ȤʤΤǹ߱ƥХ饤ɤ
     *
     *  @access public
     *  @param  string  $forward_name   forward̾
     *  @return string  view class饹̾
     */
    function getDefaultViewClass($forward_name, $gateway = null)
    {
        $gateway_prefix = $this->_getGatewayPrefix($gateway);

        $postfix = preg_replace('/_(.)/e', "strtoupper('\$1')", ucfirst($forward_name));
        $r = sprintf("%s_%sView_%s", $this->getAppId(), $gateway_prefix ? $gateway_prefix . "_" : "", $postfix);
        $this->logger->log(LOG_DEBUG, "default view class [%s]", $r);

        return $r;
    }

    /**
     *  ̾бӥ塼ѥ̾ά줿Υǥեȥѥ֤̾
     *
     *  ǥեȤǤ"foo_bar" -> "/Foo/Bar.php"ȤʤΤǹ߱ƥС饤ɤ
     *
     *  @access public
     *  @param  string  $forward_name   forward̾
     *  @return string  view class륹ץȤΥѥ̾
     */
    function getDefaultViewPath($forward_name)
    {
        $r = preg_replace('/_(.)/e', "'/' . strtoupper('\$1')", ucfirst($forward_name)) . '.' . $this->getExt('php');
        $this->logger->log(LOG_DEBUG, "default view path [%s]", $r);

        return $r;
    }

    /**
     *  ̾бƥץ졼ȥѥ̾ά줿Υǥեȥѥ֤̾
     *
     *  ǥեȤǤ"foo_bar"Ȥforward̾"foo/bar" + ƥץ졼ȳĥҤȤʤ
     *  Τǹ߱ƥХ饤ɤ
     *
     *  @access public
     *  @param  string  $forward_name   forward̾
     *  @return string  forwardѥ̾
     */
    function getDefaultForwardPath($forward_name)
    {
        return str_replace('_', '/', $forward_name) . '.' . $this->ext['tpl'];
    }
    
    /**
     *  ƥץ졼ȥѥ̾̾
     *
     *  getDefaultForwardPath()򥪡С饤ɤ硢碌ƥС饤
     *  뤳Ȥ侩(ɬܤǤϤʤ)
     *
     *  @access public
     *  @param  string  $forward_path   ƥץ졼ȥѥ̾
     *  @return string  ̾
     */
    function forwardPathToName($forward_path)
    {
        $forward_path = preg_replace('/^\/+/', '', $forward_path);
        $forward_path = preg_replace(sprintf('/\.%s$/', $this->getExt('tpl')), '', $forward_path);

        return str_replace('/', '_', $forward_path);
    }

    /**
     *  ̾ƥץ졼ȥեΥѥ̾
     *
     *  @access private
     *  @param  string  $forward_name   forward̾
     *  @return string  ƥץ졼ȥեΥѥ̾
     */
    function _getForwardPath($forward_name)
    {
        $forward_obj = null;

        if (isset($this->forward[$forward_name]) == false) {
            // try default
            $this->forward[$forward_name] = array();
        }
        $forward_obj =& $this->forward[$forward_name];
        if (isset($forward_obj['forward_path']) == false) {
            // ά
            $forward_obj['forward_path'] = $this->getDefaultForwardPath($forward_name);
        }

        return $forward_obj['forward_path'];
    }

    /**
     *  ƥץ졼ȥ󥸥(ߤsmartyΤб)
     *
     *  @access public
     *  @return object  Smarty  ƥץ졼ȥ󥸥󥪥֥
     */
    function &getTemplateEngine()
    {
        $smarty =& new Smarty();
        $smarty->template_dir = $this->getTemplatedir();
        $smarty->compile_dir = $this->getDirectory('template_c');
        $smarty->compile_id = md5($smarty->template_dir);

        // ФäƤߤ
        if (@is_dir($smarty->compile_dir) == false) {
            mkdir($smarty->compile_dir, 0755);
        }
        $smarty->plugins_dir = $this->getDirectory('plugins');

        // default modifiers
        $smarty->register_modifier('number_format', 'smarty_modifier_number_format');
        $smarty->register_modifier('strftime', 'smarty_modifier_strftime');
        $smarty->register_modifier('count', 'smarty_modifier_count');
        $smarty->register_modifier('join', 'smarty_modifier_join');
        $smarty->register_modifier('filter', 'smarty_modifier_filter');
        $smarty->register_modifier('unique', 'smarty_modifier_unique');
        $smarty->register_modifier('wordwrap_i18n', 'smarty_modifier_wordwrap_i18n');
        $smarty->register_modifier('truncate_i18n', 'smarty_modifier_truncate_i18n');
        $smarty->register_modifier('i18n', 'smarty_modifier_i18n');
        $smarty->register_modifier('checkbox', 'smarty_modifier_checkbox');
        $smarty->register_modifier('select', 'smarty_modifier_select');
        $smarty->register_modifier('form_value', 'smarty_modifier_form_value');

        // user defined modifiers
        foreach ($this->smarty_modifier_plugin as $modifier) {
            $name = str_replace('smarty_modifier_', '', $modifier);
            $smarty->register_modifier($name, $modifier);
        }

        // default functions
        $smarty->register_function('is_error', 'smarty_function_is_error');
        $smarty->register_function('message', 'smarty_function_message');
        $smarty->register_function('uniqid', 'smarty_function_uniqid');
        $smarty->register_function('select', 'smarty_function_select');
        $smarty->register_function('checkbox_list', 'smarty_function_checkbox_list');
        $smarty->register_function('form_name', 'smarty_function_form_name');
        $smarty->register_function('form_input', 'smarty_function_form_input');

        // user defined functions
        foreach ($this->smarty_function_plugin as $function) {
            
            if (!is_array($function)) {
                $name = str_replace('smarty_function_', '', $function);
                $smarty->register_function($name, $function);
            } else {
                $smarty->register_function($function[1], $function);
            }

        }

        // default blocks
        $smarty->register_block('form', 'smarty_block_form');

        // user defined blocks
        foreach ($this->smarty_block_plugin as $block) {
            
            if (!is_array($block)) {
                $name = str_replace('smarty_block_', '', $block);
                $smarty->register_block($name, $block);
            } else {
                $smarty->register_block($block[1], $block);
            }

        }

        // user defined prefilters
        foreach ($this->smarty_prefilter_plugin as $prefilter) {
            $smarty->register_prefilter($prefilter);
        }

        // user defined postfilters
        foreach ($this->smarty_postfilter_plugin as $postfilter) {
            $smarty->register_postfilter($postfilter);
        }

        // user defined outputfilters
        foreach ($this->smarty_outputfilter_plugin as $outputfilter) {
            $smarty->register_outputfilter($outputfilter);
        }

        $this->_setDefaultTemplateEngine($smarty);

        return $smarty;
    }

    /**
     *  ƥץ졼ȥ󥸥ΥǥեȾ֤ꤹ
     *
     *  @access protected
     *  @param  object  Smarty  $smarty ƥץ졼ȥ󥸥󥪥֥
     */
    function _setDefaultTemplateEngine(&$smarty)
    {
    }

    /**
     *  Ѹꤹ
     *
     *  ؤγĥΤΤߤ¸ߤƤޤߤä˥С饤ɤɬפϤޤ
     *
     *  @access protected
     *  @param  string  $language           (LANG_JA, LANG_EN...)
     *  @param  string  $system_encoding    ƥ२󥳡ǥ̾
     *  @param  string  $client_encoding    饤ȥ󥳡ǥ
     */
    function _setLanguage($language, $system_encoding = null, $client_encoding = null)
    {
        $this->language = $language;
        $this->system_encoding = $system_encoding;
        $this->client_encoding = $client_encoding;

        $i18n =& $this->getI18N();
        $i18n->setLanguage($language, $system_encoding, $client_encoding);
    }

    /**
     *  ǥեȾ֤ǤλѸ
     *
     *  @access protected
     *  @return array   Ѹ,ƥ२󥳡ǥ̾,饤ȥ󥳡ǥ̾
     */
    function _getDefaultLanguage()
    {
        return array(LANG_JA, null, null);
    }

    /**
     *  ǥեȾ֤ǤΥȥ
     *
     *  @access protected
     *  @return int     ȥ(GATEWAY_WWW, GATEWAY_CLI...)
     */
    function _getDefaultGateway($gateway)
    {
        if (is_null($GLOBALS['_Ethna_gateway']) == false) {
            return $GLOBALS['_Ethna_gateway'];
        }
        return GATEWAY_WWW;
    }

    /**
     *  ȥб饹̾Υץե
     *
     *  @access public
     *  @param  string  $gateway    ȥ
     *  @return string  ȥ饹ץե
     */
    function _getGatewayPrefix($gateway = null)
    {
        $gateway = is_null($gateway) ? $this->getGateway() : $gateway;
        switch ($gateway) {
        case GATEWAY_WWW:
            $prefix = '';
            break;
        case GATEWAY_CLI:
            $prefix = 'Cli';
            break;
        case GATEWAY_XMLRPC:
            $prefix = 'Xmlrpc';
            break;
        default:
            $prefix = '';
            break;
        }

        return $prefix;
    }

    /**
     *  ޥ͡㥯饹̾
     *
     *  @access public
     *  @param  string  $name   ޥ̾͡
     *  @return string  ޥ͡㥯饹̾
     */
    function getManagerClassName($name)
    {
        return sprintf('%s_%sManager', $this->getAppId(), ucfirst($name));
    }

    /**
     *  󥹥ץȤ򥤥󥯥롼ɤ
     *
     *  󥯥롼ɤե˥饹Ƥ뤫ɤݾڤʤ
     *
     *  @access private
     *  @param  array   $action_obj     
     *  @param  string  $action_name    ̾
     */
    function _includeActionScript($action_obj, $action_name)
    {
        $class_path = $form_path = null;

        $action_dir = $this->getActiondir();

        // class_path°å
        if (isset($action_obj['class_path'])) {
            // եѥꥵݡ
            $tmp_path = $action_obj['class_path'];
            if (Ethna_Util::isAbsolute($tmp_path) == false) {
                $tmp_path = $action_dir . $tmp_path;
            }

            if (file_exists($tmp_path) == false) {
                $this->logger->log(LOG_WARNING, 'class_path file not found [%s] -> try default', $tmp_path);
            } else {
                include_once($tmp_path);
                $class_path = $tmp_path;
            }
        }

        // ǥեȥå
        if (is_null($class_path)) {
            $class_path = $this->getDefaultActionPath($action_name);
            if (file_exists($action_dir . $class_path)) {
                include_once($action_dir . $class_path);
            } else {
                $this->logger->log(LOG_DEBUG, 'default action file not found [%s] -> try all files', $class_path);
                $class_path = null;
            }
        }
        
        // ե륤󥯥롼
        if (is_null($class_path)) {
            $this->_includeDirectory($this->getActiondir());
            return;
        }

        // form_path°å
        if (isset($action_obj['form_path'])) {
            // եѥꥵݡ
            $tmp_path = $action_obj['class_path'];
            if (Ethna_Util::isAbsolute($tmp_path) == false) {
                $tmp_path = $action_dir . $tmp_path;
            }

            if ($tmp_path == $class_path) {
                return;
            }
            if (file_exists($tmp_path) == false) {
                $this->logger->log(LOG_WARNING, 'form_path file not found [%s] -> try default', $tmp_path);
            } else {
                include_once($tmp_path);
                $form_path = $tmp_path;
            }
        }

        // ǥեȥå
        if (is_null($form_path)) {
            $form_path = $this->getDefaultFormPath($action_name);
            if ($form_path == $class_path) {
                return;
            }
            if (file_exists($action_dir . $form_path)) {
                include_once($action_dir . $form_path);
            } else {
                $this->logger->log(LOG_DEBUG, 'default form file not found [%s] -> maybe falling back to default form class', $form_path);
            }
        }
    }

    /**
     *  ӥ塼ץȤ򥤥󥯥롼ɤ
     *
     *  󥯥롼ɤե˥饹Ƥ뤫ɤݾڤʤ
     *
     *  @access private
     *  @param  array   $forward_obj    
     *  @param  string  $forward_name   ̾
     */
    function _includeViewScript($forward_obj, $forward_name)
    {
        $view_dir = $this->getViewdir();

        // view_path°å
        if (isset($forward_obj['view_path'])) {
            // եѥꥵݡ
            $tmp_path = $forward_obj['view_path'];
            if (Ethna_Util::isAbsolute($tmp_path) == false) {
                $tmp_path = $view_dir . $tmp_path;
            }

            if (file_exists($tmp_path) == false) {
                $this->logger->log(LOG_WARNING, 'view_path file not found [%s] -> try default', $tmp_path);
            } else {
                include_once($tmp_path);
                return;
            }
        }

        // ǥեȥå
        $view_path = $this->getDefaultViewPath($forward_name);
        if (file_exists($view_dir . $view_path)) {
            include_once($view_dir . $view_path);
            return;
        } else {
            $this->logger->log(LOG_DEBUG, 'default view file not found [%s]', $view_path);
            $view_path = null;
        }
    }

    /**
     *  ǥ쥯ȥʲƤΥץȤ򥤥󥯥롼ɤ
     *
     *  @access private
     */
    function _includeDirectory($dir)
    {
        $ext = "." . $this->ext['php'];
        $ext_len = strlen($ext);

        if (is_dir($dir) == false) {
            return;
        }

        $dh = opendir($dir);
        if ($dh) {
            while (($file = readdir($dh)) !== false) {
                if ($file != '.' && $file != '..' && is_dir("$dir/$file")) {
                    $this->_includeDirectory("$dir/$file");
                }
                if (substr($file, -$ext_len, $ext_len) != $ext) {
                    continue;
                }
                include_once("$dir/$file");
            }
        }
        closedir($dh);
    }

    /**
     *  եDSNѤǡƹۤ(졼֥ʬ)
     *
     *  DSNˡ(ǥե:ե)ѤϤ򥪡С饤ɤ
     *
     *  @access protected
     *  @return array   DSN(array('DB1' => 'dsn1', 'DB2' => 'dsn2', ...))
     */
    function _prepareDSN()
    {
        $r = array();

        foreach ($this->db as $key => $value) {
            $config_key = "dsn";
            if ($key != "") {
                $config_key .= "_$key";
            }
            $dsn = $this->config->get($config_key);
            if (is_array($dsn)) {
                // 1ĤˤĤʣDSNƤϥʬ
                $dsn = $this->_selectDSN($key, $dsn);
            }
            $r[$key] = $dsn;
        }
        return $r;
    }

    /**
     *  DSNΥʬԤ
     *  
     *  졼֥Фؤοʬ(ǥե:)ѹϤΥ᥽åɤ򥪡С饤ɤ
     *
     *  @access protected
     *  @param  string  $type       DB
     *  @param  array   $dsn_list   DSN
     *  @return string  򤵤줿DSN
     */
    function _selectDSN($type, $dsn_list)
    {
        if (is_array($dsn_list) == false) {
            return $dsn_list;
        }

        // ǥե:
        list($usec, $sec) = explode(' ', microtime());
        mt_srand($sec + ((float) $usec * 100000));
        $n = mt_rand(0, count($dsn_list)-1);
        
        return $dsn_list[$n];
    }

    /**
     *  Ethnaޥ͡ꤹ
     *
     *  פʾ϶Υ᥽åɤȤƥС饤ɤƤ褤
     *
     *  @access protected
     */
    function _activateEthnaManager()
    {
        if ($this->config->get('debug') == false) {
            return;
        }

        include_once(ETHNA_BASE . '/class/Ethna_InfoManager.php');
        
        // see if we have simpletest
        if (file_exists_ex('simpletest/unit_tester.php', true)) {
            include_once(ETHNA_BASE . '/class/Ethna_UnitTestManager.php');
        }

        // action
        $this->action['__ethna_info__'] = array(
            'form_name' =>  'Ethna_Form_Info',
            'form_path' =>  sprintf('%s/class/Action/Ethna_Action_Info.php', ETHNA_BASE),
            'class_name' => 'Ethna_Action_Info',
            'class_path' => sprintf('%s/class/Action/Ethna_Action_Info.php', ETHNA_BASE),
        );

        // forward
        $this->forward['__ethna_info__'] = array(
            'forward_path'  => sprintf('%s/tpl/info.tpl', ETHNA_BASE),
            'view_name'     => 'Ethna_View_Info',
            'view_path'     => sprintf('%s/class/View/Ethna_View_Info.php', ETHNA_BASE),
        );
        
        
        // action
        $this->action['__ethna_unittest__'] = array(
            'form_name' =>  'Ethna_Form_UnitTest',
            'form_path' =>  sprintf('%s/class/Action/Ethna_Action_UnitTest.php', ETHNA_BASE),
            'class_name' => 'Ethna_Action_UnitTest',
            'class_path' => sprintf('%s/class/Action/Ethna_Action_UnitTest.php', ETHNA_BASE),
        );

        // forward
        $this->forward['__ethna_unittest__'] = array(
            'forward_path'  => sprintf('%s/tpl/unittest.tpl', ETHNA_BASE),
            'view_name'     => 'Ethna_View_UnitTest',
            'view_path'     => sprintf('%s/class/View/Ethna_View_UnitTest.php', ETHNA_BASE),
        );

    }

    /**
     *  CLI¹ե饰
     *
     *  @access public
     *  @return bool    CLI¹ե饰
     *  @obsolete
     */
    function getCLI()
    {
        return $this->gateway == GATEWAY_CLI ? true : false;
    }

    /**
     *  CLI¹ե饰ꤹ
     *
     *  @access public
     *  @param  bool    CLI¹ե饰
     *  @obsolete
     */
    function setCLI($cli)
    {
        $this->gateway = $cli ? GATEWAY_CLI : $this->_getDefaultGateway();
    }
}
// }}}

/**
 *  XMLRPCȥΥ֥饹
 *
 *  @access     public
 */
function _Ethna_XmlrpcGateway($method_stub, $param)
{
    $ctl =& Ethna_Controller::getInstance();
    $method = $ctl->getXmlrpcMethodName();
    $r = $ctl->trigger_XMLRPC($method, $param);
    if (Ethna::isError($r)) {
        return array(
            'faultCode' => $r->getCode(),
            'faultString' => $r->getMessage(),
        );
    }
    return $r;
}
?>
